# Dotgrid

Dotgrid is a simple vector drawing application. 

<img src='https://raw.githubusercontent.com/hundredrabbits/Dotgrid/master/PREVIEW.jpg' width="600"/>

## Guide

Clicking on the canvas will insert control points, up to 3CPs. CPs can be moved with the arrows. Clicking one of the path icons, or pressing one of the shortcuts, will draw a stroke between them. The newly created segment's handles can be moved by clicking and dragging them.

## Controls

### File
- New: `CmdOrCtrl+N`
- Open: `CmdOrCtrl+O`
- Save: `CmdOrCtrl+S`

### Edit
- Copy: `CmdOrCtrl+C`
- Cut: `CmdOrCtrl+X`
- Paste: `CmdOrCtrl+V`
- Undo: `CmdOrCtrl+Z`
- Redo: `CmdOrCtrl+Shift+Z`
- Delete: `Backspace`
- Deselect: `Esc`

### Stroke
- Line: `A`
- Arc: `S`
- Arc Rev: `D`
- Bezier: `F`
- Connect: `Z`

### Effect
- Linecap: `Q`
- Linejoin: `W`
- Mirror: `E`
- Thicker: `}`
- Thinner: `{`
- Thicker +5: `]`
- Thinner -5: `[`

### Layers
- Foreground: `CmdOrCtrl+1`
- Middleground: `CmdOrCtrl+2`
- Background: `CmdOrCtrl+3`

### View
- Tools: `U`
- Grid: `H`
- Control Points: `J`

### Mode
- Toggle Size: `CmdOrCtrl+E`
- Keyboard: `CmdOrCtrl+K`
- Picker: `CmdOrCtrl+P`

## keyboard Mode

### Controls
- Add vertex: `Enter`
- Remove vertex: `Backspace`

### Select
- Move Up: `Up`
- Move Down: `Down`
- Move Left: `Left`
- Move Right: `Right`
- XXYY(0): `0`
- XXYY(1): `1`
- XXYY(2): `2`
- XXYY(3): `3`
- XXYY(4): `4`
- XXYY(5): `5`
- XXYY(6): `6`
- XXYY(7): `7`
- XXYY(8): `8`
- XXYY(9): `9`

### Mode
- Stop Keyboard Mode: `Escape`

## picker Mode

### Edit
- undo: `undefined`
- redo: `undefined`
- cut: `undefined`
- copy: `undefined`
- paste: `undefined`
- delete: `undefined`
- selectall: `undefined`

### Mode
- Stop Picker Mode: `Escape`

<img src='https://cdn.rawgit.com/hundredrabbits/Dotgrid/master/LAYOUT.svg?v=3' width="600"/>

## Extras

- Download additional [themes](https://github.com/hundredrabbits/Themes).
- Support this project through [Patreon](https://patreon.com/100).
- See the [License](LICENSE.md) file for license rights and limitations (MIT).
